"""add_role_and_user_role_table

Revision ID: aa3b6ded81f6
Revises: 947dad7dbfdb
Create Date: 2024-04-20 22:46:46.280013

"""

from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = "aa3b6ded81f6"
down_revision = "947dad7dbfdb"
branch_labels = None
depends_on = None


def upgrade():
    # op.execute("CREATE EXTENSION IF NOT EXISTS pg_trgm")
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "system_role",
        sa.Column("id", sa.BigInteger(), nullable=False),
        sa.Column("name", sa.String(length=32), nullable=True, comment="角色名"),
        sa.Column("sort", sa.Integer(), nullable=True, comment="排序"),
        sa.Column("remark", sa.String(), nullable=True, comment="备注信息"),
        sa.Column("create_time", sa.DateTime(), nullable=True),
        sa.Column("update_time", sa.DateTime(), nullable=True),
        sa.PrimaryKeyConstraint("id"),
        comment="角色信息表",
    )
    op.create_index(op.f("ix_system_role_id"), "system_role", ["id"], unique=False)
    op.create_index(op.f("ix_system_role_name"), "system_role", ["name"], unique=False)
    op.create_table(
        "system_user_role",
        sa.Column("id", sa.BigInteger(), nullable=False),
        sa.Column("user_id", sa.BigInteger(), nullable=True, comment="用户Id"),
        sa.Column("role_id", sa.BigInteger(), nullable=True, comment="角色Id"),
        sa.Column("create_time", sa.DateTime(), nullable=True),
        sa.Column("update_time", sa.DateTime(), nullable=True),
        sa.PrimaryKeyConstraint("id"),
        sa.UniqueConstraint("user_id", "role_id", name="uix_user_id_role_id"),
        comment="用户角色关联表",
    )
    op.create_index(
        "idx_user_role_id", "system_user_role", ["user_id", "role_id"], unique=False
    )
    op.create_index(
        op.f("ix_system_user_role_id"), "system_user_role", ["id"], unique=False
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index(op.f("ix_system_user_role_id"), table_name="system_user_role")
    op.drop_index("idx_user_role_id", table_name="system_user_role")
    op.drop_table("system_user_role")
    op.drop_index(op.f("ix_system_role_name"), table_name="system_role")
    op.drop_index(op.f("ix_system_role_id"), table_name="system_role")
    op.drop_table("system_role")
    # ### end Alembic commands ###
